﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace RoboRaceAuto
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    string Server;
    string ID;
    RoboRace Race;
    Lerak Lerak;
    bool Lock;

    private void StartCallback(IAsyncResult result)
    {
      HttpWebRequest request = (HttpWebRequest)result.AsyncState;
      HttpWebResponse response = (HttpWebResponse)request.EndGetResponse(result);
      TextReader reader = new StreamReader(response.GetResponseStream());
      string[] radky = reader.ReadToEnd().Split(new string[] { "\r\n" }, StringSplitOptions.None);
      this.ID = radky[0];
      this.Race = new RoboRace(radky, 1);
      string[] rr = radky[21].Split(' ');
      this.Lerak = new Lerak(this.Race, Convert.ToInt32(rr[0]) - 1, Convert.ToInt32(rr[1]) - 1, rr[2][0]);
      this.Lock = false;

      Hledat();
    }

    private void button1_Click_1(object sender, EventArgs e)
    {
      this.textBox1.Enabled = false;
      this.button1.Enabled = false;
      this.Server = this.textBox1.Text;
      HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://" + this.Server + "/start");
      this.Lock = true;
      request.BeginGetResponse(new AsyncCallback(StartCallback), request);
    }

    int WO = 0;
    List<Lerak>[] SeznamCilu = new List<Lerak>[2];
    List<List<TypPohybu>>[] SeznamCest = new List<List<TypPohybu>>[2];

    private void Hledat()
    {
      this.SeznamCilu[0] = new List<Lerak>();
      this.SeznamCilu[1] = new List<Lerak>();
      this.SeznamCest[0] = new List<List<TypPohybu>>();
      this.SeznamCest[1] = new List<List<TypPohybu>>();
      WO = 0;
      this.SeznamCilu[0].Add(this.Lerak);
      this.SeznamCest[0].Add(new List<TypPohybu>());
      cilNalezen = false;

      while(this.SeznamCilu[WO].Count > 0 && !cilNalezen)
      {
        for(int i = 0; i < this.SeznamCilu[WO].Count; i++)
        {
          Lerak v = this.SeznamCilu[WO][i];
          this.DoHloubky(v, this.SeznamCest[WO][i].ToArray().ToList(), new TypPohybu[] { TypPohybu.Doleva, TypPohybu.Doprava, TypPohybu.Vpred1, TypPohybu.Vpred2, TypPohybu.Vpred3, TypPohybu.Zpet }, new bool[6], 5);
        }
        this.SeznamCilu[WO] = new List<Lerak>();
        this.SeznamCest[WO] = new List<List<TypPohybu>>();
        WO = 1 - WO;
      }

      if(cilNalezen)
      {
        int offset = 0;
        while(offset < this.cilovaCesta.Count)
        {
          string cesta = "";
          for(int i = 0; i < 5; i++)
            if(offset + i >= this.cilovaCesta.Count)
              break;
            else
              cesta += RoboRace.TypPohybuNaZnak(this.cilovaCesta[offset + i]);
          offset += 5;
          HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://" + this.Server + "/kolo?id=" + this.ID + "&pohyby=" + cesta);
          request.GetResponse();
        }
      }
    }

    bool cilNalezen = false;
    List<TypPohybu> cilovaCesta;

    private void PridatCil(Lerak kde, List<TypPohybu> cesta)
    {
      this.SeznamCilu[1 - WO].Add(kde);
      this.SeznamCest[1 - WO].Add(cesta);
    }

    private void JitDoCile(List<TypPohybu> cesta)
    {
      cilNalezen = true;
      cilovaCesta = cesta;
    }

    private bool DoHloubky(Lerak vychozi, List<TypPohybu> zadane, TypPohybu[] povolene, bool[] pouzite, int zbyva)
    {
      if(zbyva == 0 || this.Race.Mapa[vychozi.X, vychozi.Y] == TypPolicka.Poklad)
      {
        if(this.Race.Mapa[vychozi.X, vychozi.Y] == TypPolicka.Poklad)
          this.JitDoCile(zadane);
        else
          this.PridatCil(vychozi, zadane);
        if(vychozi.X < 0 || vychozi.Y < 0 || vychozi.X > 19 || vychozi.Y > 19)
          return false;
        return true;
      }

      Lerak predLerak = vychozi.Clone();
      for(int i = 0; i < povolene.Length; i++)
        if(!pouzite[i])
        {
          if(predLerak.Pohyb(povolene[i]))
          {
            pouzite[i] = true;
            zadane.Add(povolene[i]);
            if(!this.DoHloubky(predLerak, zadane, povolene, pouzite, zbyva - 1))
            {
              zadane.RemoveAt(zadane.Count - 1);
              pouzite[i] = false;

              predLerak = vychozi.Clone();
            }
          }
          else
            predLerak = vychozi.Clone();
        }
      return false;
    }

  }
}
