﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;

namespace RoboRaceInteraktivni
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    string Server;
    string ID;
    RoboRace Race;
    Lerak Lerak;
    Lerak ZalohaLeraka;
    TypPohybu[] Povolene;
    bool[] Pouzite;
    List<TypPohybu> Zadane;
    bool Mrtvy;
    bool Lock = false;

    private void button1_Click(object sender, EventArgs e)
    {
      this.textBox1.Enabled = false;
      this.button1.Enabled = false;
      this.button2.Visible = true;
      this.Server = this.textBox1.Text;
      HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://" + this.Server + "/start");
      this.Lock = true;
      request.BeginGetResponse(new AsyncCallback(StartCallback), request);
    }

    private void StartCallback(IAsyncResult result)
    {
      HttpWebRequest request = (HttpWebRequest)result.AsyncState;
      HttpWebResponse response = (HttpWebResponse)request.EndGetResponse(result);
      TextReader reader = new StreamReader(response.GetResponseStream());
      string[] radky = reader.ReadToEnd().Split(new string[] {"\r\n"}, StringSplitOptions.None);
      this.ID = radky[0];
      this.Race = new RoboRace(radky, 1);
      string[] rr = radky[21].Split(' ');
      this.Lerak = new Lerak(this.Race, Convert.ToInt32(rr[0]) - 1, Convert.ToInt32(rr[1]) - 1, rr[2][0]);
      this.NastavitPovolene(radky[22]);

      this.Lock = false;
      this.Invoke(new Action(PrvniVykresleni));
    }

    private void NastavitPovolene(string radek)
    {
      this.checkBox = this.checkBox1.Checked;
      this.Zadane = new List<TypPohybu>();
      this.ZalohaLeraka = this.Lerak.Clone();
      this.Mrtvy = false;
      this.Pouzite = new bool[radek.Length];
      this.Pouzite.Initialize();
      this.Povolene = new TypPohybu[radek.Length];
      for(int i = 0; i < this.Povolene.Length; i++)
        this.Povolene[i] = RoboRace.ZnakNaTypPohybu(radek[i]);
    }

    Color[] barvy = new Color[] { Color.Green, Color.Green, Color.Green, Color.Green, Color.White, Color.Black, Color.Red, Color.Yellow };
    private void PrvniVykresleni()
    {
      StringBuilder sb = new StringBuilder(this.Povolene.Length);
      for(int i = 0; i < this.Povolene.Length; i++)
        sb.Append(RoboRace.TypPohybuNaZnak(this.Povolene[i]));
      this.label2.Text = sb.ToString();

      this.label1.Text = "";

      this.Prekreslit();
    }

    private void Prekreslit()
    {
      this.g.Clear(Color.SkyBlue);
      for(int iY = 0; iY < 20; iY++)
        for(int iX = 0; iX < 20; iX++)
          this.Vykreslit(this.Race.Mapa[iX, iY], iX, iY);
      this.Vykreslit(this.ZalohaLeraka, true);
      this.Vykreslit(this.Lerak, false);
    }

    private void Vykreslit(TypPolicka typ, int x, int y)
    {
      SolidBrush b = new SolidBrush(barvy[(int)typ]);
      SolidBrush bA = new SolidBrush(Color.LightGreen);
      double sirka = this.pictureBox1.Width / 21;
      double vyska = this.pictureBox1.Height / 21;
      this.g.FillRectangle(b, (float)(sirka * (x + 0.5)+1), (float)(vyska * (y + 0.5)+1), (float)(sirka-2), (float)(vyska-2));
      if((int)typ < 4)
        this.g.FillPie(bA, (float)(sirka * (x + 0.625)), (float)(vyska * (y + 0.625)), (float)(sirka * 0.75), (float)(vyska * 0.75), -135 + 90 * (int)typ, 90);
    }
    private void Vykreslit(Lerak lerak, bool kopie, bool cil = false)
    {
      SolidBrush b = new SolidBrush((kopie ? Color.Blue : (cil ? Color.Silver : Color.BlueViolet)));
      SolidBrush bA = new SolidBrush(Color.LightBlue);
      double sirka = this.pictureBox1.Width / 21;
      double vyska = this.pictureBox1.Height / 21;
      this.g.FillRectangle(b, (float)(sirka * (lerak.X + 0.625)), (float)(vyska * (lerak.Y + 0.625)), (float)(sirka * 0.75), (float)(vyska * 0.75));
      this.g.FillPie(bA, (float)(sirka * (lerak.X + 0.625)), (float)(vyska * (lerak.Y + 0.625)), (float)(sirka * 0.75), (float)(vyska * 0.75), -135 + 90 * lerak.Smer, 90);
    }

    Graphics g;
    private void Form1_Load(object sender, EventArgs e)
    {
      this.g = this.pictureBox1.CreateGraphics();
    }

    private void InicializovatZadane()
    {
      this.checkBox = this.checkBox1.Checked;
      this.Pouzite = new bool[this.Pouzite.Length];
      this.Pouzite.Initialize();
      this.Zadane = new List<TypPohybu>();
      this.label1.Text = "";
      this.Mrtvy = false;
      this.Lerak = this.ZalohaLeraka.Clone();
      this.Prekreslit();
    }

    private void OdeslatPohyby()
    {
      HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://" + this.Server + "/kolo?id=" + this.ID + "&pohyby=" + this.label1.Text);
      this.Lock = true;
      request.BeginGetResponse(new AsyncCallback(KoloCallback), request);
    }

    private void KoloCallback(IAsyncResult result)
    {
      HttpWebRequest request = (HttpWebRequest)result.AsyncState;
      HttpWebResponse response = (HttpWebResponse)request.EndGetResponse(result);
      TextReader reader = new StreamReader(response.GetResponseStream());
      string[] radky = reader.ReadToEnd().Split(new string[] { "\r\n" }, StringSplitOptions.None);
      this.Lock = false;
      if(radky.Length < 3)
      {
        this.g.Clear(Color.SkyBlue);
        this.g.DrawString(radky[0], new Font(FontFamily.GenericMonospace, 10), new SolidBrush(Color.Black), new RectangleF(0, 0, this.pictureBox1.Width, this.pictureBox1.Height), new StringFormat() { Alignment = StringAlignment.Center, LineAlignment = StringAlignment.Center });
        this.Race = null;
      }
      else
      {
        this.NastavitPovolene(radky[22]);
        this.Invoke(new Action(PrvniVykresleni));
      }
    }

    private bool NajitPosloupnost(Lerak cil)
    {
      this.InicializovatZadane();
      return this.DoHloubky(this.Povolene, this.Pouzite, 5, cil);
    }

    private bool DoHloubky(TypPohybu[] povolene, bool[] pouzite, int zbyva, Lerak cil)
    {
      if(zbyva == 0)
        return cil.Souhlasi(this.Lerak);

      Lerak predLerak = this.Lerak.Clone();
      bool[] pouziteTypy = new bool[6];
      for(int i = 0; i < povolene.Length; i++)
        if(!pouzite[i] && !pouziteTypy[(int)povolene[i]])
        {
          pouziteTypy[(int)povolene[i]] = true;
          if(this.Lerak.Pohyb(povolene[i]))
          {
            pouzite[i] = true;
            this.Zadane.Add(povolene[i]);
            if(this.DoHloubky(povolene, pouzite, zbyva - 1, cil))
              return true;
            else
            {
              this.Zadane.RemoveAt(this.Zadane.Count - 1);
              pouzite[i] = false;

              this.Lerak = predLerak.Clone();
            }
          }
          else
            this.Lerak = predLerak.Clone();
        }
      return false;
    }

    bool checkBox = true;
    private void Form1_KeyPress(object sender, KeyPressEventArgs e)
    {
      if(this.Race == null || this.Lock)
        return;

      TypPohybu typ = (TypPohybu)(-1);
      switch(e.KeyChar)
      {
        case '1': typ = TypPohybu.Vpred1; break;
        case '2': typ = TypPohybu.Vpred2; break;
        case '3': typ = TypPohybu.Vpred3; break;
        case '4': typ = TypPohybu.Doleva; break;
        case '6': typ = TypPohybu.Doprava; break;
        case '0': typ = TypPohybu.Zpet; break;
        case '-':
          this.InicializovatZadane();
          break;
        case '\r':
          DialogResult r = System.Windows.Forms.DialogResult.Yes;
          if(checkBox)
          {
            if(this.Mrtvy)
              r = MessageBox.Show("Toto Leraka zabije. Chcete pokračovat?", "Varování", MessageBoxButtons.YesNo);
            else if((this.Zadane == null || this.Zadane.Count < 5) && this.Race.Mapa[this.Lerak.X, this.Lerak.Y] != TypPolicka.Poklad)
              r = MessageBox.Show("Nebyl zadán dostatečný počet kroků. Chcete pokračovat?", "Varování", MessageBoxButtons.YesNo);
          }
          else
          {
            foreach(TypPohybu tp in this.Zadane)
              if(!this.Lerak.Pohyb(tp))
                break;
          }
          if(r == System.Windows.Forms.DialogResult.Yes)
            this.OdeslatPohyby();
          break;
      }
      e.KeyChar = (char)1;
      if((int)typ != -1 && this.Zadane.Count < 5 && !this.Mrtvy)
      {
        if(this.Zadane == null || this.Zadane.Count == 5)
          this.InicializovatZadane();

        int nalez = -1;
        for(int i = 0; i < this.Povolene.Length; i++)
          if(this.Povolene[i] == typ && !this.Pouzite[i])
          {
            nalez = i;
            break;
          }

        if(nalez >= 0)
        {
          this.Pouzite[nalez] = true;

          this.Zadane.Add(typ);
          this.label1.Text += RoboRace.TypPohybuNaZnak(typ);
          if(checkBox)
          {
            int minX = this.Lerak.X;
            int minY = this.Lerak.Y;
            if(!this.Lerak.Pohyb(typ))
            {
              this.Vykreslit(this.Race.Mapa[minX, minY], minX, minY);
              this.Vykreslit(this.ZalohaLeraka, true);
              this.Vykreslit(this.Lerak, false);
              this.Mrtvy = true;
              this.g.DrawString("Mrtev!", new Font(FontFamily.GenericSansSerif, 30), new SolidBrush(Color.White), new RectangleF(0, 0, this.pictureBox1.Width, this.pictureBox1.Height), new StringFormat() { Alignment = StringAlignment.Center, LineAlignment = StringAlignment.Center });
            }
            else
            {
              this.Vykreslit(this.Race.Mapa[minX, minY], minX, minY);
              this.Vykreslit(this.ZalohaLeraka, true);
              this.Vykreslit(this.Lerak, false);
            }
          }
        }
      }
    }

    Lerak Cil;
    private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
    {
      if(this.Race == null)
        return;

      double sirka = this.pictureBox1.Width / 21;
      double vyska = this.pictureBox1.Height / 21;
      int x = (int)Math.Floor(e.X / sirka - 0.5);
      int y = (int)Math.Floor(e.Y / sirka - 0.5);

      this.Cil = new Lerak(this.Race, x, y, this.Lerak.Smer);
      this.Vykreslit(this.Cil, false, true);
    }

    private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
    {
      if(this.Race == null || this.Cil == null)
        return;

      this.pictureBox1_MouseMove(sender, e);

      if(this.NajitPosloupnost(this.Cil))
      {
        foreach(TypPohybu typ in this.Zadane)
          this.label1.Text += RoboRace.TypPohybuNaZnak(typ);
        this.Vykreslit(this.ZalohaLeraka, true);
        this.Vykreslit(this.Lerak, false);
      }
      else
      {
        this.Zadane = null;
        this.label1.Text = "Cesta nebyla nalezena.";
      }
      this.Cil = null;
    }

    private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
    {
      if(this.Race == null || this.Cil == null)
        return;

      double sirka = this.pictureBox1.Width / 21;
      double vyska = this.pictureBox1.Height / 21;
      int x = (int)Math.Floor(e.X / sirka - 0.5);
      int y = (int)Math.Floor(e.Y / sirka - 0.5);

      if(Math.Abs(this.Cil.X - x) > Math.Abs(this.Cil.Y - y))
        if(this.Cil.X > x)
          this.Cil.Smer = 3;
        else
          this.Cil.Smer = 1;
      else
        if(this.Cil.Y > y)
          this.Cil.Smer = 0;
        else
          this.Cil.Smer = 2;
      this.Vykreslit(this.Cil, false, true);
    }

    private void button2_Click(object sender, EventArgs e)
    {
      this.Race = null;
      this.textBox1.Enabled = true;
      this.button1.Enabled = true;
      this.button2.Visible = false;
    }

    private void Form1_ResizeEnd(object sender, EventArgs e)
    {
      this.g = this.pictureBox1.CreateGraphics();

      if(this.Race != null)
        this.Prekreslit();
    }

    private void button3_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Lerak se ovládá nejlépe pomocí numerické klávesnice. Čísla 1, 2 a 3 jsou příkazy pro chůzi vpřed, 0 pro chůzi vzad, čísla 4 a 6 provádějí otočení (4 doleva, 6 doprava). Pomocí Enteru lze odeslat aktuální sekvenci a skutečně se posunout. Pomocí znaku - lze zresetovat aktuální nastavenou sekvenci.\r\n\r\nVolná pole mají bílou barvu, zdi černou. Díry jsou červené a poklad žlutý. Pásy mají zelenou barvu a jejich směr je označen kruhovou výsečí v daném směru. Lerak může být vykreslen až třemi barvami - modrý je výchozí pozice, fialový je pozice po odehrání sekvence a stříbrný je zadaný cíl (viděn pouze při zadávání).\r\n\r\nPro zadání cíle stačí stisknout tlačítko myši nad vytouženým cílovým políčkem a tahem myši určit, do jakého směru by měl být následně Lerak otočen.", "Nápověda");
    }
  }
}
